#define INCL_NOCOMMON
#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#define INCL_DOSFILEMGR
#define INCL_DOSERRORS
#define INCL_DOSMEMMGR
#define INCL_WINWINDOWMGR
#define INCL_WINMESSAGEMGR
#define INCL_WINFRAMEMGR
#define INCL_WINDIALOGS
#define INCL_WININPUT
#define INCL_WINSTDFILE                /* Window Standard File         */
#define INCL_WINSTDFONT
#define INCL_WINSWITCHLIST
#define INCL_WINPROGRAMLIST
#define INCL_GPICONTROL
#define INCL_GPIPRIMITIVES
#define  INCL_PM
#define INCL_DOS
#include <os2.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>

#include "Dbf\dbfversion.h"
#include "list\list.h"
#include "Dbf\DbfFieldTypes.h"
#include "Dbf\DbfField.h"
#include "Dbf\DbfHeader.h"
#include "Dbf\DbfRecord.h"
#include "Dbf\Dbf.h"


int main(int argc, char *argv[])
{

   CHAR LoadError[256];
   USHORT rc;
   HMODULE HMDbf;
   DBF_STRUCT Dbf;
   DBFRECORD_STRUCT *record;
   PSZ **ptrRecordData;
   float fNetWorth;
   long lAge;
   DATETIME CurDate;
   CHAR dbfFile[100];
   CHAR dbfDLL[100];
   CHAR testDBF[100];
   HFILE hfCSV;
   ULONG action;
   CHAR csvFile[100];

   strcpy(dbfFile, "dbase_30.dbf");
   strcpy(dbfDLL,"Dbf.DLL");
   strcpy(csvFile, "dbase_30.csv");
   strcpy(testDBF, "Test.dbf");

   if (argc > 1)
   {
      int argcNum;
      for (argcNum = 1; argcNum < argc; argcNum++)
      {
         if (strnicmp(argv[argcNum], "/dbf=", 5) == 0)
         {
            strncpy(dbfFile, &argv[argcNum][5], 100);
         }
         if (strnicmp(argv[argcNum], "/dbfout=", 8) == 0)
         {
            strncpy(csvFile, &argv[argcNum][8], 100);
         }
         if (strnicmp(argv[argcNum], "/testdbf=", 9) == 0)
         {
            strncpy(testDBF, &argv[argcNum][9], 100);
         }
      }
   }

   rc = DosLoadModule(LoadError,sizeof(LoadError),dbfDLL,&HMDbf);
   rc = DosQueryProcAddr(HMDbf,0,"DbfNew",&Dbf.New);

   memcpy(&Dbf,Dbf.New(), sizeof(DBF_STRUCT));

   Dbf.Read(dbfFile);

   rc = DosOpen(csvFile,&hfCSV,&action,0L,FILE_NORMAL,
         OPEN_ACTION_CREATE_IF_NEW | OPEN_ACTION_REPLACE_IF_EXISTS,OPEN_SHARE_DENYNONE | OPEN_ACCESS_WRITEONLY,0L);
   if (rc == 0)
   {
      DBFFIELD_STRUCT *ptrdbfFields = (DBFFIELD_STRUCT *)Dbf.Fields->array;
      ULONG ulBytesWritten;
      int x,y;
      int iMaxFieldSize = 0;
      PSZ RecordData;
      record = (DBFRECORD_STRUCT *)Dbf.Records->array;

      for (y = 0; y < Dbf.Fields->size; y++)
      {

         if (y > 0)
            DosWrite(hfCSV, "\",", 2, &ulBytesWritten);
         DosWrite(hfCSV, "\"", 1, &ulBytesWritten);

         DosWrite(hfCSV, ptrdbfFields[y].Name, strlen(ptrdbfFields[y].Name), &ulBytesWritten);
         if (ptrdbfFields[y].Length > iMaxFieldSize)
            iMaxFieldSize = ptrdbfFields[y].Length;

      }

      iMaxFieldSize += 1;
      DosWrite(hfCSV, "\"\r\n", 3, &ulBytesWritten);

      for (x = 0; x < Dbf.Records->size; x++)
      {
         int iOffset = 0;
         BYTE cData[256];
         CHAR szFormat[20];

         RecordData = (PSZ)record[x].Data->array;
         for (y = 0; y < Dbf.Fields->size; y++)
         {
            iOffset = iMaxFieldSize * y;
            if (y > 0)
               DosWrite(hfCSV, ",", 1, &ulBytesWritten);
            switch(ptrdbfFields[y].Type)
            {
               case Character:
               case Date:
               {
                  memset(cData, 0x00, 256);
                  strncpy(cData, &RecordData[iOffset], ptrdbfFields[y].Length);
                  /*  memset(&cData[strlen(&RecordData[iOffset])], 0x20, ptrdbfFields[y].Length - strlen(&RecordData[y])); */
                  DosWrite(hfCSV, "\"", 1, &ulBytesWritten);
                  DosWrite(hfCSV, cData, ptrdbfFields[y].Length, &ulBytesWritten);
                  DosWrite(hfCSV, "\"", 1, &ulBytesWritten);

                  break;
               }
               case Integer:
               case Memo:
               {
                  int *ptrInt = &RecordData[iOffset];
                  memset(cData, 0x00, 20);
                  itoa(*ptrInt,cData,10);
                  DosWrite(hfCSV, cData, strlen(cData), &ulBytesWritten);

                  break;
               }
               case Currency:
               case Double:
               {
                  double dData;
                  memcpy(&dData, &RecordData[iOffset], sizeof(double));
                  memset(cData, 0x00, 200);
                  sprintf(szFormat, " .%df", ptrdbfFields[y].Precision);
                  szFormat[0] = '%';
                  sprintf(cData, szFormat, dData);
                  DosWrite(hfCSV, cData,ptrdbfFields[y].Length , &ulBytesWritten);

                  break;
               }
               case Numeric:
               case Float:
               {
                  float fData;

                  memcpy(&fData, &RecordData[iOffset], sizeof(float));
                  memset(cData, 0x00, 20);
                  sprintf(szFormat, " .%df", ptrdbfFields[y].Precision);
                  szFormat[0] = '%';
                  sprintf(cData, szFormat, fData);
                  DosWrite(hfCSV, cData, strlen(cData), &ulBytesWritten);

                  break;
               }
               case TimeStamp:
               case DateTime:
               {

                  DATETIME date;
                  ULONG jdn;
                  ULONG time;
                  int iSize = sizeof(ULONG);
                  memset(cData, 0x00, 30);

                  memcpy(&date, &RecordData[iOffset], sizeof(DATETIME));

                  sprintf(cData,"%2d/%2d/%4d %d:%2d:%2d", date.month, date.day, date.year, date.hours, date.minutes, date.seconds);
                  DosWrite(hfCSV, "\"", 1, &ulBytesWritten);
                  if (date.year == 0)
                     DosWrite(hfCSV, "                    ", 20, &ulBytesWritten);
                  else
                     DosWrite(hfCSV, cData, strlen(cData), &ulBytesWritten);
                  DosWrite(hfCSV, "\"", 1, &ulBytesWritten);
                  break;
               }
               case Logical:
                  if (RecordData[iOffset] == 1)
                     DosWrite(hfCSV, "Y", 1, &ulBytesWritten);
                  else
                     DosWrite(hfCSV, "N", 1, &ulBytesWritten);
                  break;
               default:
                  printf("Error: Unsupported Type\r\n");
                  break;

            }

         }
         DosWrite(hfCSV, "\r\n", 2, &ulBytesWritten);

      }



      DosClose(hfCSV);
   }

   Dbf.Dispose(); /*     DO NOT FORGET    */


   DosGetDateTime(&CurDate);
   rc = DosQueryProcAddr(HMDbf,0,"DbfNew",&Dbf.New);
   memcpy(&Dbf,Dbf.New(), sizeof(DBF_STRUCT));

   Dbf.List->Add((VOID *)Dbf.Fields, Dbf.DBFField->DbfField4("TEST", Character, 12, 0), sizeof(DBFFIELD_STRUCT));
   Dbf.List->Add((VOID *)Dbf.Fields, Dbf.DBFField->DbfField4("NAME", Character, 30, 0), sizeof(DBFFIELD_STRUCT));
   Dbf.List->Add((VOID *)Dbf.Fields, Dbf.DBFField->DbfField4("AGE", Integer, 4, 0), sizeof(DBFFIELD_STRUCT));
   Dbf.List->Add((VOID *)Dbf.Fields, Dbf.DBFField->DbfField4("NET WORTH", Float, 12, 2), sizeof(DBFFIELD_STRUCT));
   Dbf.List->Add((VOID *)Dbf.Fields, Dbf.DBFField->DbfField4("LAST SEEN", Date, 8, 0), sizeof(DBFFIELD_STRUCT));
   Dbf.List->Add((VOID *)Dbf.Fields, Dbf.DBFField->DbfField4("RIGHT NOW", TimeStamp, 12, 0), sizeof(DBFFIELD_STRUCT));
   record = Dbf.CreateRecord();
   ptrRecordData = (PSZ)record->Data->array;
   strcpy(ptrRecordData[0], "Hello");
   strcpy(ptrRecordData[1], "Daffy Duck");
   lAge = 40;
   memcpy(ptrRecordData[2],&lAge, sizeof(long));
   fNetWorth = 2000.00;
   memcpy(ptrRecordData[3],&fNetWorth, sizeof(fNetWorth));
   strcpy(ptrRecordData[4], "20231119");
   memcpy(ptrRecordData[5],&CurDate, sizeof(CurDate));

   record = Dbf.CreateRecord();
   ptrRecordData = (PSZ)record->Data->array;
   lAge = 60;
   strcpy(ptrRecordData[0], "Not So");
   strcpy(ptrRecordData[1], "Yogi Bear");
   memcpy(ptrRecordData[2],&lAge, sizeof(long));
   fNetWorth = 350000.28;
   memcpy(ptrRecordData[3],&fNetWorth, sizeof(fNetWorth));
   strcpy(ptrRecordData[4], "20230405");
   memcpy(ptrRecordData[5],&CurDate, sizeof(CurDate));

   record = Dbf.CreateRecord();
   lAge = 64;
   ptrRecordData = (PSZ)record->Data->array;
   strcpy(ptrRecordData[0], "Oh My");
   strcpy(ptrRecordData[1], "Cat In the Hat");
   memcpy(ptrRecordData[2],&lAge, sizeof(long));
   fNetWorth = 36374.96;
   memcpy(ptrRecordData[3],&fNetWorth, sizeof(fNetWorth));
   strcpy(ptrRecordData[4], "20240306");
   memcpy(ptrRecordData[5],&CurDate, sizeof(CurDate));

   Dbf.Write(testDBF,FoxBaseDBase3NoMemo);


   Dbf.Dispose(); /*     DO NOT FORGET    */

   return;




}

